# map_test.py
import time
from multiprocessing import Pool


def f(x):
    return x**3


y = range(int(1e7))

p = Pool(processes=4)

# map function
start = time.time()
results = p.map(f, y)  # blocking
end = time.time()
print ("map blocks")
print ("time", end - start)

# map_async
start = time.time()
results = p.map_async(f, y)  # non-blocking
end = time.time()
print ("map_async is non-blocking")
output = results.get()  # but get() is blocking
print ("time", end - start)

